Index: moodle/mod/forum/styles.css
--- moodle/mod/forum/styles.css Base (1.3)
+++ moodle/mod/forum/styles.css Locally Modified (Based On 1.3)
@@ -51,3 +51,8 @@
 #user-view .forumpost,
 .course .forumpost {width: 100%;}
 #email .unsubscribelink {margin-top:20px;}
+
+/** Styles for right to left layout */
+.dir-rtl .forumpost .picture {float: right; }
+.dir-rtl .forumpost .content {float:right; padding:0;}
+

Index: moodle/mod/quiz/styles.css
--- moodle/mod/quiz/styles.css Base (1.5)
+++ moodle/mod/quiz/styles.css Locally Modified (Based On 1.5)
@@ -119,8 +119,8 @@
 
 table.quizreviewsummary {width: 100%;}
 table.quizreviewsummary th.cell {padding: 1px 0.5em 1px 1em;font-weight: bold;text-align: right;width: 10em;background: #f0f0f0;}
-table.quizreviewsummary td.cell {padding: 1px 1em 1px 0.5em;text-align: left;background: #fafafa;}
-
+table.quizreviewsummary td.cell {padding: 1px 1em 1px 0.5em;background: #fafafa;}
+.dir-rtl table.quizreviewsummary th.cell {text-align: left;}
 .path-mod-quiz #user-picture {margin: 0.5em 0;}
 .path-mod-quiz #user-picture img {width: auto;height: auto;float: left;}
 .path-mod-quiz .othernav {clear: both;}
@@ -349,3 +349,30 @@
 .ie6#page-mod-quiz-edit div.question div.content .questionname {width:20%;}
 .ie6#page-mod-quiz-edit .editq div.question div.content .randomquestioncategory a{width:40%;}
 .ie6#page-mod-quiz-edit .reorder .questioncontentcontainer .randomquestioncategory label{width: 35%;}
+
+/** Overide for RTL layout **/
+.path-mod-quiz.dir-rtl .que .info{float: right; text-align: right;}
+#page-mod-quiz-report.dir-rtl table#attempts .header  {text-align: right;}
+#page-mod-quiz-mod.dir-rtl #reviewoptionshdr fieldset.fgroup {text-align: right; margin-right: 0px;}
+
+.dir-rtl .questionbankwindow.block {float:left;}
+#page-mod-quiz-edit.dir-rtl div.quizcontents {float:right; clear:right;}
+#page-mod-quiz-mod.dir-rtl #reviewoptionshdr fieldset.fgroup span {float: right; clear: right;}
+
+#page-mod-quiz-edit.dir-rtl div.question div.content div.questioncontrols {float:left; left:0.3em;}
+#page-mod-quiz-edit.dir-rtl div.question div.content div.points {left: 50px; right:0px;position:relative;top:0em;float:left;}
+#page-mod-quiz-edit.dir-rtl div.question div.content div.questioncontentcontainer {float:left;}
+
+#page-mod-quiz-edit.dir-rtl div.quizpage span.pagetitle,
+#page-mod-quiz-edit.dir-rtl div.quizpage .pagecontent {float:right;}
+
+#page-mod-quiz-edit.dir-rtl .statusdisplay {margin-left: 1em; margin-right:0;}
+#page-mod-quiz-edit.dir-rtl div.quizpage .pagecontent {float:right;margin-right:0.3em;border-right:solid #777 thin;border-left-width: 0;}
+
+#page-mod-quiz-edit.dir-rtl div.editq div.question div.content,
+#page-mod-quiz-edit.dir-rtl div.editq div.question div.qnum {float: right;}
+
+.path-mod-quiz .clearfloat {float:none; clear:both; height: 0;}
+#page-mod-quiz-edit.dir-rtl .addpage {float: left; margin-left: 2em; margin-right:0;}
+
+#page-mod-quiz-review.dir-rtl .que .qtext {text-align: right;}
Index: moodle/theme/base/style/core.css
--- moodle/theme/base/style/core.css Base (1.51)
+++ moodle/theme/base/style/core.css Locally Modified (Based On 1.51)
@@ -636,6 +636,10 @@
 .dir-rtl .mform .fitem .fitemtitle {float:right;}
 .dir-rtl .loginbox .loginform .form-label {float:right;text-align:left;}
 .dir-rtl .loginbox .loginform .form-input {text-align: right;}
+.dir-rtl table#tag-management-list,
+.dir-rtl table#tag-management-list td,
+.dir-rtl table#tag-management-list th {text-align: right;}
+.dir-rtl .mform fieldset .advancedbutton {text-align:left;}
 
 /**
  * Backup

Index: moodle/theme/formal_white/style/formalwhite.css
--- moodle/theme/formal_white/style/formalwhite.css Base (1.2)
+++ moodle/theme/formal_white/style/formalwhite.css Locally Modified (Based On 1.2)
@@ -123,3 +123,8 @@
   /* overflow: hidden; */
     display:block;
 }
+
+/** Overide for RTL layout **/
+.dir-rtl #logo {
+    float: right;
+}

Index: moodle/theme/formal_white/style/fw_corners.css
--- moodle/theme/formal_white/style/fw_corners.css Base (1.1)
+++ moodle/theme/formal_white/style/fw_corners.css Locally Modified (Based On 1.1)
@@ -19,7 +19,15 @@
     height:17px;
     margin:0 0 0 17px;
 }
+.dir-rtl div.headerleft div {
+    background-image: url([[pix:theme|roundcorner/header_r]]);
+}
 
+.dir-rtl div.headerleft div {
+    background-image: url([[pix:theme|roundcorner/header_l]]);
+    margin:0 100% 0 0px;    
+}
+

 div.bodyleft { /* Page background left */
     background-image: url([[pix:theme|roundcorner/body_l]]);
     background-repeat:repeat-y;